<?php

namespace App\Http\Controllers\Admin;

use App\About;
use Exception;
use Illuminate\View\View;
use Illuminate\Http\Request;
use Illuminate\Http\JsonResponse;
use Illuminate\Routing\Redirector;
use App\Http\Controllers\Controller;
use App\Http\Requests\AboutRequest;
use Illuminate\Http\RedirectResponse;

class AboutController extends Controller
{

    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/abouts';
    /** View folder */
    private $viewDirectory= 'admin.abouts.';

    /**
     * Display a listing of the resource.
     *
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('abouts.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the pages.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $query = About::latest();

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('description', 'LIKE', '%'.$request->name.'%');
        }

        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $abouts= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('abouts'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('abouts.store');
        $head= metaFields('abouts', 'add_new', getCurrentLocale()) ?? __('abouts.new');
        return view( $this->viewDirectory.'form', compact('action', 'head') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param AboutRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(AboutRequest $request) :RedirectResponse
    {

//        foreach ($request->except('images') as $key => $item) {
//            $item = strip_tags($item);
//            $request[$key] = $item;
//        }

        $description = [];
        $ceo_message = [];
        $our_message = [];
        $vision = [];

        foreach (languages() as $language) {
//            $descRequest  = trim(preg_replace('/\s\s+/', ' ', $request['description_'.$language->local]));
//            $detailsRequest  = trim(preg_replace('/\s\s+/', ' ', $request['details_'.$language->local]));
            $desc_attr = [
                'description_'.$language->local => $request['description_'.$language->local]
            ];
            $ceo_message_attr = [
                'ceo_message_'.$language->local => $request['ceo_message_'.$language->local]
            ];
            $our_message_attr = [
                'our_message_'.$language->local => $request['our_message_'.$language->local]
            ];
            $vision_attr = [
                'vision_'.$language->local => $request['vision_'.$language->local]
            ];
            $description = array_merge($description, $desc_attr);
            $ceo_message = array_merge($ceo_message, $ceo_message_attr);
            $our_message = array_merge($our_message, $our_message_attr);
            $vision = array_merge($vision, $vision_attr);
        }

        About::create([
            'description' => $description,
            'ceo_message' => $ceo_message,
            'our_message' => $our_message,
            'vision' => $vision,
            'photos' => $request->has('images') ? $request->images : null,
            'statistics' => $request->statistics,
            'experience_year' => $request->experience_year,
        ]);


        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param About $about
     * @return View
     */
    public function edit(About $about) :View
    {
        $action= route('abouts.update', $about->id);
        $head= metaFields('abouts', 'edit', getCurrentLocale()) ?? __('abouts.edit');
        return view( $this->viewDirectory.'form', compact('about', 'action', 'head') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param AboutRequest $request
     * @param About $about
     * @return RedirectResponse|Redirector
     */
    public function update(AboutRequest $request, About $about) :RedirectResponse
    {

//        foreach ($request->except('images') as $key => $item) {
//            $item = strip_tags($item);
//            $request[$key] = $item;
//        }

        $description = [];
        $ceo_message = [];
        $our_message = [];
        $vision = [];

        foreach (languages() as $language) {
//            $descRequest  = trim(preg_replace('/\s\s+/', ' ', $request['description_'.$language->local]));
//            $detailsRequest  = trim(preg_replace('/\s\s+/', ' ', $request['details_'.$language->local]));
            $desc_attr = [
                'description_'.$language->local => $request['description_'.$language->local]
            ];
            $ceo_message_attr = [
                'ceo_message_'.$language->local => $request['ceo_message_'.$language->local]
            ];
            $our_message_attr = [
                'our_message_'.$language->local => $request['our_message_'.$language->local]
            ];
            $vision_attr = [
                'vision_'.$language->local => $request['vision_'.$language->local]
            ];
            $description = array_merge($description, $desc_attr);
            $ceo_message = array_merge($ceo_message, $ceo_message_attr);
            $our_message = array_merge($our_message, $our_message_attr);
            $vision = array_merge($vision, $vision_attr);
        }

        $about->update([
            'description' => $description,
            'ceo_message' => $ceo_message,
            'our_message' => $our_message,
            'vision' => $vision,
            'photos' => $request->has('images') ? $request->images : null,
            'statistics' => $request->statistics,
            'experience_year' => $request->experience_year,
        ]);

        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }


    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $about = About::withTrashed()->find($id);
        if ($about) {
            if ($about->deleted_at) {
                $about->forceDelete();
            } else {
                $about->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            About::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            About::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $about = About::withTrashed()->find($id);

        if ($about){
            $about->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $about = About::whereIn('id', $request->ids)->onlyTrashed();
        if ($about){
            $about->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
